import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

abstract class ViewModelWidgetBuilder<T extends ViewModelBase> {
  final T viewModel;

  ViewModelWidgetBuilder({required this.viewModel});

  @mustCallSuper
  @factory
  Widget build(BuildContext context, T viewModel);
}

class ViewModelBase extends ChangeNotifier {
  bool loading = false;
  void setLoading() {
    loading = true;
    notifyListeners();
  }

  void setIdle() {
    loading = false;
    notifyListeners();
  }

  ViewModelBase();
}
