Duration parseDuration(String? s) {
  if (s == null) return Duration.zero;
  if (s.contains(':') == false) return Duration.zero;

  List<String> parts = s.split(':');

  if (parts[1].length != 2) return Duration.zero;

  int hours = 0;
  int minutes = 0;

  hours = int.parse(parts[0]);
  minutes = int.parse(parts[1]);
  return Duration(hours: hours, minutes: minutes);
}

String toHoursMinutesFormatString(String? duration) {
  return toHoursMinutesFormat(parseDuration(duration));
}

String toHoursMinutesFormat(Duration duration) {
  return _format(duration.inHours, duration.inMinutes.remainder(60));
}

String _format(int hours, int minutes) {
  return '${hours.toString().padLeft(2, '0')}:${minutes.toString().padLeft(2, '0')}';
}
